unit stringfuncs;

{

    HTML
Copyright (c) 2013  . .

}

interface

function htmlspecialchars_decode (s : ANSIString) : ANSIString;

function htmlspecialchars (s : ANSIString) : ANSIString;

//   
function trim (const Line : string) : string;

//        
function str_replace (s,ToFind,ToReplace : ANSIString; var Counter : integer) : ANSIString;

//     ,    (,       -)
function FIOToString (SurName,Name,FatherName : ANSIString) : ANSIString;

//      
function SNILSToNumber (SNILS : string) : string;

//        
function NumberToSNILS (Number : string) : string;

//         HTML-
function f2s (f : Currency) : ANSIString;

//         Excel-
function f2s2 (f : Currency) : ANSIString;

//    ..  
function dateDMYToYMD (D : ANSIString) : ANSIString;


implementation

uses SysUtils;

//         HTML-
function f2s (f : Currency) : ANSIString;
const
 a : array [1..6] of integer = (4,7,10,13,16,19);
var
 s,t   : ANSIString;
 i,j,p : integer;
begin
 //    
 Str (f:15:2,s);
 //   
 while s [1] = ' ' do s := Copy (s,2,Length (s)-1);
 //   
 t := '';
 p := Pos ('.',s);
 if p <> 0 then t := Copy (s,p,Length (s) - p + 1) else p := Length (s) + 1;
 for i := p - 1 downto 1
  do begin
      for j := 1 to Length (a)
       do if a [j] = p - i
        then begin
              t := ' ' + t;
              Break;
             end;
      t := s [i] + t;
     end;
 Result := str_replace (t,'.',',',p);
end;

function f2s2 (f : Currency) : ANSIstring;
var
 s   : string;
begin
 Str (f:15:2,s);
 //   
 while s [1] = ' ' do s := Copy (s,2,Length (s)-1);
 Result := s;
end;

//   
function trim (const Line : string) : string;
var
 r : string;
 b : Boolean;
begin
 r := Line;
 if (r <> '')
  then begin
        //  
        repeat
         b := False;
         if r <> '' then if (r [1] = #13) or (r [1] = #10) or (r [1] = #32) or (r [1] = #9) then b := True;
         if b then r := copy (r,2,Length (r)-1);
        until b = False;
        //  
        repeat
         b := False;
         if r <> '' then if (r [Length (r)] = #13) or (r [Length (r)] = #10) or (r [Length (r)] = #32) or (r [Length (r)] = #9) then b := True;
         if b then r := copy (r,1,Length (r)-1);
        until b = False;
       end;
 trim := r;
end;

function strlpos (const SubStr,Str : ANSIString; StartPos : integer) : integer;
var
 i,i1 : integer;
 b,b1 : Boolean;
begin
 if StartPos > Length (Str) then strlpos := 0
 else if Length (Str) < Length (SubStr) then strlpos := 0
 else if Length (SubStr) = 0 then strlpos := 0
 else begin
       i := StartPos;
       b := False;
       strlpos := 0;
       while (i <= Length (Str) - Length (SubStr) + 1) and (b = False)
        do begin
            if Str [i] = SubStr [1]
             then begin
                   b1 := True;
                   if Length (SubStr) = 1
                    then begin
                          strlpos := i;
                          Break;
                         end
                    else for i1 := 2 to Length (SubStr)
                     do if (i + i1 - 2) <= Length (Str)
                      then begin
                            if Str [i + i1 - 2] = SubStr [i1] then b1 := False;
                            if b1 = False
                             then Break
                             else begin
                                   b := True;
                                   strlpos := i;
                                  end;
                           end
                      else begin
                            strlpos := 0;
                            Break;
                           end;

                  end;
            Inc (i);
           end;
      end;
end;

//        
function str_replace (s,ToFind,ToReplace : ANSIString; var Counter : integer) : ANSIString;
var
 a   : ANSIString;
 i,j : integer;
begin
 Counter := 0;
 if  Pos (ToFind,s) = 0 then str_replace := s
 else begin
       a := s;
       i := 1;
       repeat
        j := strlpos (ToFind,a,i);
        if j > 0
         then begin
               Inc (Counter);
               i := j + Length (ToReplace);
               a := Copy (a,1,j-1) + ToReplace + Copy (a,j+Length (ToFind),Length (a)-j-Length (ToFind)+1);
              end;
       until j = 0;
       str_replace := a;
      end;
end;

function htmlspecialchars_decode (s : ANSIString) : ANSIString;
const
 ReplaceArr : array [1..8,1..2] of ANSIString =
  (
   ('quot','"'),
   ('laquo',''),
   ('raquo',''),
   ('gt','>'),
   ('lt','<'),
   ('amp','&'),
   ('#039',#39),
   ('nbsp',' ')
  );

var
 Counter,i : integer;
 a         : ANSIString;
begin
 a := s;
 for i := 1 to 8 do a := str_replace (a,'&'+ReplaceArr [i,1]+';',ReplaceArr [i,2],Counter);
 Result := a;
end;

function htmlspecialchars (s : ANSIString) : ANSIString;
const
 ReplaceArr : array [1..7,1..2] of ANSIString =
  (
   ('quot','"'),
   ('laquo',''),
   ('raquo',''),
   ('gt','>'),
   ('lt','<'),
   ('amp','&'),
   ('#039',#39)
  );

var
 Counter,i : integer;
 a         : ANSIString;
begin
 a := s;
 for i := 1 to 7 do a := str_replace (a,ReplaceArr [i,2],'&'+ReplaceArr [i,1]+';',Counter);
 Result := a;
end;

function FIOToString (SurName,Name,FatherName : ANSIString) : ANSIString;
begin
 Result := SurName;
 if Result <> '' then Result := Result + ' ';
 Result := Result + Name;
 if Result <> '' then Result := Result + ' ';
 Result := Result + FatherName;
end;

function SNILSToNumber (SNILS : string) : string;
var
 s : string;
 i : integer;
begin
 if Length (SNILS) <> 14 then SNILSToNumber := SNILS
 else begin
       s := '';
       for i := 1 to Length (SNILS) do if (SNILS [i] >= '0') and (SNILS [i] <= '9') then s := s + SNILS [i];
       SNILSToNumber := s;
      end;
end;

//        
function NumberToSNILS (Number : string) : string;
begin
 Result := Copy (Number,1,3)+'-'+Copy (Number,4,3)+'-'+Copy (Number,7,3)+' '+Copy (Number,10,2);
end;

//    ..  
function dateDMYToYMD (D : ANSIString) : ANSIString;
begin
 Result := Copy (D,7,4) + Copy (D,4,2) + Copy (D,1,2);
end;

end.